<?php
require_once((defined("RHACO_DIR")?constant("RHACO_DIR"):"")."Rhaco.php");
require_once((defined("RHACO_DIR")?constant("RHACO_DIR"):"")."resources/Message.php");
require_once((defined("RHACO_DIR")?constant("RHACO_DIR"):"")."tag/HtmlParser.php");
require_once((defined("RHACO_DIR")?constant("RHACO_DIR"):"")."tag/TagUtil.php");
require_once((defined("RHACO_DIR")?constant("RHACO_DIR"):"")."io/FileUtil.php");
require_once((defined("RHACO_DIR")?constant("RHACO_DIR"):"")."network/http/Request.php");
require_once((defined("RHACO_DIR")?constant("RHACO_DIR"):"")."exception/data/RequireException.php");
require_once((defined("RHACO_DIR")?constant("RHACO_DIR"):"")."exception/data/DuplicateException.php");
require_once((defined("RHACO_DIR")?constant("RHACO_DIR"):"")."exception/data/IllegalStateException.php");
require_once((defined("RHACO_DIR")?constant("RHACO_DIR"):"")."exception/ExceptionTrigger.php");
require_once((defined("RHACO_DIR")?constant("RHACO_DIR"):"")."contribute/ContributeInstaller.php");
/**
 * @author Kazutaka Tokushima
 * @license New BSD License
 * @copyright Copyright 2005- The Rhacophorus Project. All rights reserved.
 */
class AuthFileManager{
	var $htmlParser;
	var $tagUtil;
	var $request;
	var $memberfile;
	var $fileUtil;

	function AuthFileManager($memberfile=""){
		$this->fileUtil		= new FileUtil();
		$this->htmlParser 	= new HtmlParser();
		$this->tagUtil 		= new TagUtil();
		$this->request		= new Request();
		$this->memberfile	= (empty($memberfile)) ? Rhaco::resource(".member.xml") : $memberfile;
	}
	
	function template(){
		if(!$this->fileUtil->exist($this->memberfile)){
			$tag = new SimpleTag("auth");
			$this->fileUtil->write($this->memberfile,$tag->get());
		}else{
			$src	= $this->fileUtil->read($this->memberfile);
			$src	= trim($src);
			
			if(empty($src)){
				$tag = new SimpleTag("auth");
				$this->fileUtil->write($this->memberfile,$tag->get());				
			}else{
				$tag = new SimpleTag();
				if(!$tag->set($src,"auth")){
					ExceptionTrigger::raise(new IllegalStateException($this->memberfile));
				}
			}
		}
		if($this->request->isPost()){
			$tag = new SimpleTag("user");

			if($this->request->isVariable("delete")){
				$tag->setParameter("login",$this->request->getVariable("login"));
				$this->tagUtil->delete($this->memberfile,$tag);
			}else{
				$login		= $this->request->getVariable("login");
				$password	= $this->request->getVariable("password");

				if(empty($login)){
					ExceptionTrigger::raise(new RequireException(Message::_("Login")));
				}
				if(empty($password)){
					ExceptionTrigger::raise(new RequireException(Message_("Password")));
				}
				if(!ExceptionTrigger::isException()){
					$tag->setParameter("login",$login);

					if($this->tagUtil->get($this->memberfile,$tag) != false){
						ExceptionTrigger::raise(new DuplicateException(Message::_("Login")));
					}else{
						$tag->setParameter("password",md5($password));	
						$this->tagUtil->insert($this->memberfile,$tag);
					}
				}
			}
			$this->tagUtil->commit($this->memberfile);
		}
		$this->request->setVariable("userList",$this->tagUtil->select($this->memberfile,new SimpleTag("user")));
		$this->htmlParser->setVariable($this->request->getVariable());
		$this->htmlParser->setFileName(ContributeInstaller::path("tag/auth/resources/templates/memberManager.html"));
		return $this->htmlParser;
	}
}
?>