<?php
require_once((defined("RHACO_DIR")?constant("RHACO_DIR"):"")."network/http/Http.php");
/**
 * @author Kazutaka Tokushima
 * @license New BSD License
 * @copyright Copyright 2006- The Rhacophorus Project. All rights reserved.
 */
class Browser{
	var $cookie		= array();
	var $variables	= array();
	var $agent		= "Rhaco Browser";
	var $user		= "";
	var $password	= "";

	function post($url){
		return $this->_request($url,"POST");
	}
	function get($url){
		return $this->_request($url,"GET");
	}
	function setBasicAuthorization($user,$password){
		$this->user		= $user;
		$this->password	= $password;
	}
	function _request($url,$method="GET"){
		$cookies		= "";
		$variables	= "";
		$headers		= array();

		foreach(Variable::toArray($this->cookie) as $name => $cookie){
			$cookies .= sprintf("%s=%s; ",$name,$cookie);
		}		
		if(!empty($this->variables)){
			$variables = TemplateFormatter::httpBuildQuery($this->variables);

			if(strtoupper($method) == "GET"){
				$url = (strpos($url,"?") === false) ? $url."?" : $url."&";
				$url .= $variables;
			}else{
				$headers["Content-Type"]		= "application/x-www-form-urlencoded";
				$headers["Content-Length"]	= strlen($variables);
				$headers["variables"]			= $variables;
			}
		}
		$headers["Cookie"]			= $cookies;
		$headers["User-Agent"]		= $this->agent;

		if(!empty($this->user)){
			if(preg_match("/^([\w]+:\/\/)(.+)$/",$url,$matches)){
				$url = $matches[1].$this->user.":".$this->password."@".$matches[2];
			}else{
				$url = "http://".$this->user.":".$this->password."@".$url;
			}
		}
		list($head,$body) = Http::request($url,$method,$headers);
		$this->_parseHeader($head);
		return $body;
	}
	function _parseHeader($header){
		if(preg_match_all("/Set-Cookie: (.+)/i",$header,$matches)){
			$unsetcookie	= array();
			$setcookie	= array();
			
			foreach($matches[1] as $cookies){
				foreach(explode(";",$cookies) as $cookie){
					$cookie = trim($cookie);

					if(preg_match("/^(.+?)=(.+)$/",$cookie,$match)){
						if(strtolower($match[1]) == "expires" && DateUtil::parseString($match[1]) < time()){
							$unsetcookie[$cookies] = 1;
						}else{
							$setcookie[$cookies][$match[1]] = $match[2];
						}
					}
				}
			}
			foreach($setcookie as $cookies){
				foreach($cookies as $cookie => $value){
					$this->cookie[$cookie] = $value;
				}
			}
			foreach($unsetcookie as $cookies => $value){
				unset($this->cookie[$cookie]);
			}
		}
	}
	function setVariable(){
		$argList = func_get_args();

		if(is_array($argList[0])){
			foreach($argList[0] as $key => $value){
				$this->variables[$key] = $value;
			}
		}else{
			$this->variables[$argList[0]] = $argList[1];
		}
	}
	function clearVariable(){
		if(func_num_args() == 0){
			$this->variables = array();
		}else{
			foreach(func_get_args() as $name){
				foreach(Variable::toArray($name) as $val){
					unset($this->variables[$val]);
				}
			}
		}
	}
	function setAgent($agent){
		$this->agent = $agent;
	}
}
?>